<%
'*********************************************************
'
'   Tektronix Windows 2000 Print Status ASP Page Project
'
'   Copyright (c) Tektronix, Inc. 1999
'
'   Description
'
'	This file contains Microsoft VBScript definitions compatable with the 
'	Microsoft IIS Active Server Page 3.0 scripting engine. 
'
'	The file defines the English display text strings for the 
'	for the NT5 Printer Status page. A seperate file with the same name 
'	must be generated for the French, Italian, German, Spanish, and 
'	Japaneses translations. All translations must use the UTF-8 encoding format. 
'	Strings with the comment ' Do not translate immediately next to the string are 
'	not to be translated.	
'
'	Implementation Note: The functions named textGpidXXX() and 
'	textPrtXXX() bind SNMP object enumerations to the 
'	display text. This would have to be un-done if a protocol other 
'	than SNMP is ever used.
' 
'   History
'
'       Version 1.0 7/22/99     Greg Thornton
'	Version 1.1 8/12/99	Greg Thornton
'
'*********************************************************

'*********************************************************
' htmlLanguage - This constant must be set to the
' "language" string associated with the localization of
' this file. The constant is used as an argument in the URL used to
' to link to the Tektronix web site.
'*********************************************************
Const htmlLanguage 		= "english"	' Do not translate
'Const htmlLanguage 		= "french"	' Do not translate
'Const htmlLanguage 		= "german"	' Do not translate
'Const htmlLanguage 		= "italian"	' Do not translate
'Const htmlLanguage 		= "spanish"	' Do not translate
'Const htmlLanguage 		= "katakana"	' Do not translate

'*********************************************************
' ResponseCodePage - This constant controls the character 
' encoding format used for the HTML response sent back to 
' the client browser. The constant must be set to the
' appropriate encoding format for a given langauage, i.e.  
' 1252 (ISO-8859-1) for French, Italian, German, and Spanish,
' and 932 (Shift-JIS) for Japanese.
'
'*********************************************************
Const ResponseCodePage		= 1252

'*********************************************************
'
' text() index values
'
'*********************************************************
Const PAPER_TRAYS		= 0
Const LOCAL_PRINTER_INFO	= 1 
Const SUPPLIES_REMAINING	= 2
Const PAGE_COUNT		= 3
Const YOUR_PRINTER		= 4
Const TEKTRONIX_COM		= 5 
Const PRINTER_STATUS		= 6
Const PERCENT			= 7
Const SEPERATOR			= 8
Const PERCENT_REMAINING		= 9
Const PERCENT_LIFE_REMAINING	= 10
Const CONTACT			= 11
Const PRINTER_LOCATION		= 12
Const PAGES			= 13
Const PHASERLINK		= 14
Const COLOR_CONNECTION		= 15 
Const ORDER_SUPPLIES		= 16
Const REGISTER_PRINTER		= 17
Const MANUALS			= 18
Const TECHNICAL_SUPPORT		= 19
Const PRINTER_SETUP_DESC	= 20
Const PAGES_REMAINING		= 21
Const T_EMPTY			= 22
Const REMOVED			= 23
Const LOW			= 24
Const OK			= 25
Const SUPPLIES			= 26
Const ERROR_TITLE		= 27
Const ERROR_REDIRECT		= 28
Const ERROR_SNMP		= 29
Const ERROR_HTML		= 30
Const CODE			= 31
Const DESCRIPTION		= 32
Const ERROR_ADVICE_1		= 33
Const PROCEDURE			= 34
Const SOURCE			= 35
Const ERROR_ADVICE_2		= 36


Function text(index)
	Select Case index
		Case PAPER_TRAYS		t = "PAPER TRAY(S)"		
		Case LOCAL_PRINTER_INFO		t = "LOCAL PRINTER INFORMATION"
		Case SUPPLIES_REMAINING		t = "SUPPLIES REMAINING"
		Case PAGE_COUNT			t = "PAGE COUNT"
		Case YOUR_PRINTER		t = "YOUR PRINTER"
		Case TEKTRONIX_COM		t = "TEKTRONIX.COM"
		Case PRINTER_STATUS		t = "Printer Status"
		Case PERCENT			t = "%"
		Case SEPERATOR			t = ", "
		Case PERCENT_REMAINING		t = " % Remaining"
		Case PERCENT_LIFE_REMAINING	t = " % Life Remaining"
		Case CONTACT			t = "Contact"
		Case PRINTER_LOCATION		t = "Printer Location"
		Case PAGES			t = "Pages"
		Case PHASERLINK			t = "PhaserLink"	' Use English for all translations
		Case COLOR_CONNECTION		t = "Color Connection"
		Case ORDER_SUPPLIES		t = "Order Supplies"
		Case REGISTER_PRINTER		t = "Register Printer"
		Case MANUALS			t = "User Manuals and Videos"
		Case TECHNICAL_SUPPORT		t = "Technical Support"	
		Case PRINTER_SETUP_DESC		t = "Set up your printer using Tektronix PhaserLink Software."
		Case PAGES_REMAINING		t = "Pages Remaining"
		Case T_EMPTY			t = "Empty"
		Case REMOVED			t = "Missing"
		Case LOW			t = "Low"
		Case OK				t = "Ok"
		Case SUPPLIES			t = "SUPPLIES"	
		Case ERROR_TITLE		t = "Error generating Tektronix printer status page"
		Case ERROR_REDIRECT		t = "Redirecting to _status_nt5.shtml"
		Case ERROR_SNMP			t = "Reading printer SNMP status"
		Case ERROR_HTML			t = "Generating HTML"	
		Case CODE			t = "ASP Code: "
		Case DESCRIPTION		t = "ASP Description: "
		Case ERROR_ADVICE_1		t = "Please check to see that the printer is turned on and properly connected to the network."
		Case ERROR_ADVICE_2		t = "If the problem persists, contact Tektronix Customer Support."
		Case Else			t = ""			' Do not translate.
	End Select
	text = t
End Function

Function textGpidInputTrayId(id)
	Select Case id
		Case 1, 2 t = 	"Paper Tray"
		Case 3 t = 	"Manual Feed Tray"
		Case 4 t = 	"Media Tray"
		Case 5 t = 	"Upper Tray"
		Case 6 t =   	"Middle Tray"
		Case 7 t =   	"Lower Tray"
		Case 8 t =   	"Tray 1"
		Case 9 t =   	"Tray 2"
		Case 10 t =  	"Tray 3"
		Case 11 t =  	"Tray 4"
		Case 12 t =  	"Tray 5"
		Case 13 t =  	"Continuous Roll Feeder"
		Case 14 t =  	"Continuous Fan Feeder"
		Case 15 t =  	"Multi-purpose Tray"
		Case 16 t =  	"2-Sided Printing Tray"
		Case Else t =  	"Paper Tray"
	End Select

	textGpidInputTrayId = t

End Function


Function textGpidInputStatus(status)
	Select Case status
		Case 1, 2 t = 	"Unknown Tray Status"
		Case 3 t = 	""			' Do not translate.
		Case 4 t = 	"Empty or Removed"
		Case 5 t = 	"Low"
		Case 6 t = 	"Empty or Removed"
		Case 7 t =   	"On request"
		Case 8 t =   	"Unavailable"
		Case 9 t =   	"Busy"
		Case Else t = 	"Unknown Tray Status"
	End Select

	textGpidInputStatus = t

End Function

Function textGpidInputMediaType(media_type)
	Select Case media_type
		Case 1, 2 t = 	"Unknown Media Type"
		Case 3 t = 	"Paper"
		Case 5 t = 	"Transparency"	
		Case 6 t = 	"Coated Paper"	
		Case 7 t =   	"Card Stock"	
		Case 8 t =   	"Label"		
		Case 9 t =   	"Fabric Transfer"
		Case 10 t =  	"2-Sided Printing Setting"
		Case 11 t =  	"Envelope"	
		Case 101 t =  	"Clear Film"
		Case 102 t =  	"White Film"
		Case 103 t =  	"Transfer Film"
		Case 104 t =  	"Film"	
		Case -20 t =   	"Mixed"
		Case Else t = 	"Unknown Media Type"
	End Select

	textGpidInputMediaType = t

End Function

Function textGpidInputMediaSize(size)
	Select Case size
		Case 1, 2 t = 	"Unknown Media Size"
		Case 3 t = 	"Letter"
		Case 4 t = 	"Legal"
		Case 5 t = 	"C6 Envelope"
		Case 6 t = 	"DL Envelope"
		Case 7 t =   	"#6 Envelope"
		Case 8 t =   	"#10 Envelope"
		Case 9 t =   	"Executive Envelope"
		Case 15 t =  	"Tabloid"

		Case 23 t =  	"A0"
		Case 24 t =  	"A1"
		Case 25 t =  	"A2"
		Case 26 t =  	"A3"
		Case 27 t =  	"A4"
		Case 28 t =   	"A5"
		Case 29 t = 	"A6"

		Case 34 t = 	"B4"
		Case 35 t = 	"B5"
		Case 36 t = 	"B6"
		Case 37 t = 	"C5"
		Case 38 t = 	"SRA3"

		Case 101 t = 	"Tabloid Extra" 		
		Case 102 t = 	"Oversize A" 			
		Case 103 t = 	"Tabloid Maximum" 		
		Case 104 t = 	"Tabloid Plus" 			

		Case 124 t = 	"JIS B1" 			
		Case 125 t = 	"JIS B2" 			
		Case 126 t = 	"JIS B3" 			
		Case 127 t = 	"JIS B4" 			

		Case 134 t = 	"Regular C" 			
		Case 135 t = 	"Regular D" 			
		Case 136 t = 	"Regular E" 			

		Case 143 t = 	"Architect B" 			
		Case 144 t = 	"Architect C" 			
		Case 145 t = 	"Architect D" 			
		Case 146 t = 	"Architect E" 			

		Case 147 t = 	"Film 8 x 10 inches" 		
		Case 148 t = 	"Film 10 x 12 inches" 		
		Case 149 t = 	"Film 11 x 14 inches" 		
		Case 150 t = 	"Film 14 x 17 inches" 		

		Case 157 t = 	"Special 30 x 42 inches" 	
		Case 160 t = 	"Monarch Envelope" 		
		Case 161 t = 	"Postcard" 			
		Case 162 t = 	"COM-10 Envelope" 		
		Case 163 t = 	"Statement" 			
		Case 164 t = 	"Special 8 x 10 inches" 	
		Case 165 t = 	"Letter Tabs" 			
		Case 166 t = 	"A4 Tabs" 			
		Case 167 t = 	"Folio" 			
		Case 168 t = 	"Special Folio" 		
		Case 169 t = 	"Special 312.5 x 440 mm" 	
		Case 170 t = 	"Special 12 x 18 inches" 	
		Case 171 t = 	"Special 12.5 x 18 inches" 	
		Case 172 t = 	"Special 13 x 18 inches" 	
		Case 173 t = 	"C4 Envelope" 			
		Case 174 t = 	"C5 Envelope" 			
		Case 175 t = 	"Choukei 3 Envelope" 		
		Case 176 t = 	"Kakugata 2 Envelope" 		
		Case 177 t = 	"Choukei 4 Envelope" 		

		Case 999 t = 	"Custom" 			
		Case -20 t = 	"Mixed Media Size" 		
		Case Else t = 	"Unknown Media Size" 			
	End Select

	textGpidInputMediaSize = t

End Function

Function textPrtAlertCode(code)
	Select Case code
		Case 1, 2 t = 	"Error, Cause Unknown" 			
		Case 3 t = 	"Door Open" 				
		Case 4 t = 	"Door Closed" 				
		Case 5 t = 	"Interlock Open" 			
		Case 6 t = 	"Interlock Closed" 			
		Case 7 t = 	"Configuration Changed" 		
		Case 8 t = 	"Paper Jam" 				
		Case 501 t = 	"Door Open" 				
		Case 502 t = 	"Door Closed" 				
		Case 503 t = 	"Powering Up" 				
		Case 504 t = 	"Powering Down" 			
		Case 801 t = 	"Tray Missing" 				
		Case 802 t = 	"Paper Size Change" 			
		Case 803 t = 	"Paper Weight Change" 			
		Case 804 t = 	"Paper Type Change" 			
		Case 805 t = 	"Paper Color Change" 			
		Case 806 t = 	"Paper Form Parts Change" 		
		Case 807 t = 	"Paper Tray Low" 			
		Case 808 t = 	"Paper Tray Empty" 			
		Case 901 t = 	"Output Tray Missing" 			
		Case 902 t = 	"Output Tray Almost Full" 		
		Case 903 t = 	"Output Tray Full" 			
		Case 1001 t = 	"Fuser Under Temperature" 		
		Case 1002 t = 	"Fuser Over Temperature" 		
		Case 1101 t = 	"Toner Empty" 				
		Case 1102 t = 	"Ink Empty" 			
		Case 1103 t = 	"Ink Ribbon Empty" 			
		Case 1104 t = 	"Toner Low" 				
		Case 1105 t = 	"Ink Low" 			
		Case 1106 t = 	"Ink Ribbon Low" 			
		Case 1107 t = 	"Toner Waste Receptacle Almost Full" 	
		Case 1108 t = 	"Ink Waste Receptacle Almost Full" 	
		Case 1109 t = 	"Toner Waste Receptacle Full" 		
		Case 1110 t = 	"Ink Waste Receptacle Full" 		
		Case 1111 t = 	"Imaging Unit Life Almost Over" 			
		Case 1112 t = 	"Imaging Unit Life Over" 			
		Case 1113 t = 	"Developer Almost Empty" 		
		Case 1114 t = 	"Developer Empty"
		Case 1194 t =   "Maintenance Tray Missing"			
		Case 1301 t = 	"Output Tray Missing" 			
		Case 1302 t = 	"Output Tray Almost Full" 		
		Case 1303 t = 	"Output Tray Full" 			
		Case Else t = 	"Error, Cause Unknown" 			
	End Select

	textPrtAlertCode = t

End Function

Function textGpidGeneralPrinterBusy(state)
	Select Case state
		Case 1 t = 	"Initializing" 			
		Case 2 t = 	"Ready" 			
		Case 3 t = 	"Printing" 			
		Case 4 t = 	"Warming Up" 			
		Case 5 t = 	"Cleaning" 			
		Case 6 t = 	"Standby" 			
		Case 7 t = 	"Energy Star" 			
		Case 8 t = 	"Engine Failure" 		
		Case 9 t = 	"Receiving Data" 		
		Case 10 t = 	"Processing Data" 		
		Case 11 t = 	"Printing Start Page" 		
		Case 12 t = 	"Front Panel In Use" 		
		Case 13 t = 	"Copying" 			
		Case 14 t = 	"Waiting" 			
		Case 15 t = 	"Off-line" 			
		Case 16 t = 	"Printer Error" 			
		Case 17 t = 	"Busy" 				
		Case 18 t = 	"Check Print" 			
		Case 19 t = 	"Cooling Down" 			
		Case 20 t = 	"Cooling Complete" 		
		Case 21 t = 	"Cutting Paper" 		
		Case 22 t = 	"Feeding Paper" 		
		Case 23 t = 	"Loading Paper" 		
		Case 24 t = 	"Unloading Paper" 		
		Case 25 t = 	"Loading Ink" 			
		Case 26 t = 	"Fuser Warming Up" 		
		Case 27 t = 	"Fuser Cooling Down" 		
		Case 28 t = 	"Service Mode" 			
		Case 29 t = 	"Testing" 			
		Case 30 t = 	"Waiting For Cancel" 		
		Case 31 t = 	"Manual Feed Error" 		
		Case 32 t = 	"Transient Engine Error" 	
		Case 33 t = 	"Engine Sync Error" 		
		Case 34 t = 	"Unknown Media Class" 		
		Case Else t = 	""		' Do not translate.
	End Select

	textGpidGeneralPrinterBusy = t
End Function

Function textGpidMarkerSuppliesColorId(color,model)
	Select Case color
		Case 1, 2 t = 	"Unknown Supply Type" 		
		Case 4 t = 	"Cyan" 				
		Case 5 t = 	"Magenta" 			
		Case 6 t = 	"Yellow" 			
		Case 7 t = 	"Black" 			
		Case 8 t = 	"Imaging Unit" 			
		Case 9 t = 	"Main Charge Grid" 		
		Case 10 t = 	"Transfer Kit" 			
		Case 11 t = 	"Fuser" 			
		Case 12 t = 	"Toner Discharge Unit" 		
		Case 13 t = 	"Transfer Toner Discharge Unit" 
		Case 14 t = 	"Pre-transfer Unit" 		
		Case 15 t = 	"Waste Ink Bin" 		
		Case 16 t = 	"Maintenance Tray" 		
		Case 17 t = 	"Paper Feed Unit" 		
		Case 18 t = 	"Tension Unit" 			
		Case Else t = 	""		' Do not translate.
	End Select

	textGpidMarkerSuppliesColorId = t
End Function

Function textGpidMarkerSuppliesType(supplies_type,model)
	Select Case supplies_type
		Case 1, 2 t = 	"Unknown Supply Type" 		
		Case 3 t = 	"Toner" 			
		Case 4 t = 	"Waste Toner" 			
		Case 5 t = 	"Ink" 				
		Case 6 t = 	"Ink Cartridge" 		
		Case 7 t = 	"Ink Ribbon" 			
		Case 8 t = 	"Waste Ink" 			
		Case 9 t = 	"Imaging Unit" 			
		Case 10 t = 	"Developer" 			
		Case 11 t = 	"Fuser Roll" 			
		Case 12 t = 	"Ink Status" 			
		Case 13 t = 	"Thermal Wax Ribbon" 		
		Case 14 t = 	"Waste Wax" 			
		Case 15 
			Select Case model
				Case M_740, M_550, M_560, M_540, M_780
					t = 	"Fuser Roll" 		
				Case M_840
					t = 	"Maintenance Kit Life Remaining" 		
				Case Else
					t = 	"Maintenance Kit" 		
			End Select
		Case 16 t = 	"Feeder" 			
		Case 17 t = 	"Tensioner" 			
		Case Else t = 	"Unknown Supply Type" 		
	End Select

	textGpidMarkerSuppliesType = t
End Function

Function textGpidMarkerSuppliesStatus(status)

	Select Case status
		Case 3 t = 	"Ok" 					
		Case 4,6 t = 	"User Attention Required" 		
		Case 5 t = 	"Warning, User Attention Required" 	
		Case Else t = 	"Unknown Supply Status" 		
	End Select
	textGpidMarkerSuppliesStatus = t
End Function

Function textGpidMarkerSuppliesStatusAlt(status)

	Select Case status
		Case 3 t = 	"Ok" 			
		Case 4,6 t = 	"Out" 			
		Case 5 t = 	"Low" 			
		Case Else t = 	"Unknown Supply Status" 
	End Select
	textGpidMarkerSuppliesStatusAlt = t
End Function


%>
